Subject: [RFC PATCH v3 2/5] pinctrl: add dt binding support for pinmux mappings

From: [email-masked] (Rob Herring)
Date: Tue, 17 Jan 2012 13:48:45 -0600

On 01/17/2012 01:35 PM, Stephen Warren wrote:
> Shawn Guo wrote at Friday, January 13, 2012 6:11 PM:
>> On Fri, Jan 13, 2012 at 10:33:21AM -0800, Stephen Warren wrote:
>>> So of_device_alloc(), which is called by of_platform_populate() for each
>>> device, already parses basic DT content such as reg and interrupts, and
>>> converts them to Linux resources. I'd consider parsing any pinmux properties
>>> and registering them with the pinctrl subsystem to be of a similar nature,
>>> so adding some code to of_device_alloc() that calls a core pinmux function
>>> to parse the DT node seems reasonable to me.
>>
>> I hardly believe that device tree maintainers would agree here.
>> Grant, Rob?
> 
> I'm explicitly putting Grant and Rob on the To line here to make this
> question stand out to them.
> 

But then the same could be argued for regulators, clocks and whatever
else infrastructure type bindings we have. I think the distinction here
is reg and interrupts are already standard properties of
platform_devices. As I believe Linus W said, all the pin mux/ctrl stuff
has to work for non-DT as well. So if the infrastructure is handling
this for DT, how would this work in the non-DT case?

There are already ways to hook into the device creation with bus notifiers.

Rob